<script setup lang="ts">
import { computed, inject, ref } from "vue";

import injectionSymbols from "./injectionSymbols";

import meshDescriptorsFlat from "@/data/meshDescriptorsFlat";
import type { MeSHDescriptor, MeSHTreeNode, MeSHUI } from "@/types/mesh";

const props = defineProps<{
  node: MeSHTreeNode;
  path: string;
  hasSelectedDescendants: Set<MeSHUI>;
  hasSelectedAncestors: Set<MeSHUI>;
}>();

const meshDescriptorsSelectedDirectly = inject(
  injectionSymbols.meshDescriptorsSelectedDirectly,
)!;

const lang = inject(injectionSymbols.language)!;

const isLeaf = computed(() => !props.node.children);

const isExpanded = ref(false);
function toggleExpanded() {
  isExpanded.value = !isExpanded.value;
}

const isSelected = computed(() => {
  return meshDescriptorsSelectedDirectly.value.some(
    (i) => i.ui === props.node.ui,
  );
});

function toggleSelected() {
  if (isSelected.value) {
    meshDescriptorsSelectedDirectly.value =
      meshDescriptorsSelectedDirectly.value.filter(
        (i) => i.ui !== props.node.ui,
      );
  } else {
    meshDescriptorsSelectedDirectly.value = [
      ...meshDescriptorsSelectedDirectly.value,
      meshDescriptorsFlat[props.node.ui] as MeSHDescriptor,
    ];
  }
}

const hasSelectedDescendant = computed(() => {
  return props.hasSelectedDescendants.has(props.node.ui);
});

const hasSelectedAncestor = computed(() => {
  return props.hasSelectedAncestors.has(props.node.ui);
});
</script>

<template>
  <div class="mt-1">
    <div class="custom-node">
      <label v-if="!isLeaf" class="checkbox">
        <button @click="toggleExpanded">
          <o-icon :icon="isExpanded ? 'circle-minus' : 'circle-plus'" />
        </button>
      </label>
      <o-icon v-else icon="circle" />
      <button @click="toggleSelected">
        <span
          class="tag is-medium"
          :class="{
            'is-primary': isSelected,
            'has-background-grey-lighter': hasSelectedDescendant && !isSelected,
            'is-primary is-light': hasSelectedAncestor && !isSelected,
          }"
        >
          {{ meshDescriptorsFlat[node.ui][`name_${lang}`] }}
          {{ node.uiCount && `(${node.uiCount})` }}
        </span>
      </button>
    </div>

    <ul v-if="isExpanded && !isLeaf" class="ml-5">
      <li
        v-for="[path, child] in Object.entries(node.children || {})"
        :key="child.ui"
      >
        <MeSHTreeNodeComponent
          :node="child"
          :path="path"
          :hasSelectedDescendants="hasSelectedDescendants"
          :hasSelectedAncestors="hasSelectedAncestors"
        />
      </li>
    </ul>
  </div>
</template>

<style scoped>
button {
  background: none;
  border: none;
  padding: 0;
  font: inherit;
  cursor: pointer;
}

code {
  background-color: transparent;
  color: unset;
  font-size: unset;
  padding: 0;
}

.icon {
  flex-shrink: 0;
  color: #222;
}

.custom-node {
  display: flex;
  flex-wrap: nowrap;
  align-items: center;
}
</style>
